
import os.path
from mywlcg import settings


def release_info():
    """provides a dictionary with info about the release"""

    def fetch_content(path, get_data=lambda x: x):
        data = None
        if os.path.exists(path):
            try:
                f = open(path, 'r')
            except IOError:
                pass
            else:
                data = get_data(f.readline().strip())
                f.close()
        return data or "error"

    return {
        'sam_release': fetch_content(settings.SAM_RELEASE_FILE),
        'mywlcg_version': fetch_content(
            '/usr/share/mywlcg/media/ChangeLog.txt',
            lambda s: s.split(' ')[-1]
        )
    }
