from django import template
from mywlcg import settings

register = template.Library()

@register.tag(name="beginace")
def do_ace(parser, token):
    nodelist = parser.parse(('endace',))
    parser.delete_first_token()
    if settings.ACE:
        return ReturnNode(nodelist)
    else:
        return ReturnEmpty()

@register.tag(name="begindax")
def do_dax(parser, token):
    nodelist = parser.parse(('enddax',))
    parser.delete_first_token()
    if settings.DAX:
        return ReturnNode(nodelist)
    else:
        return ReturnEmpty()

@register.tag(name="beginreports")
def do_reports(parser, token):
    nodelist = parser.parse(('endreports',))
    parser.delete_first_token()
    if settings.REPORTS:
        return ReturnNode(nodelist)
    else:
        return ReturnEmpty()

@register.tag(name="beginatp")
def do_atp(parser, token):
    nodelist = parser.parse(('endatp',))
    parser.delete_first_token()
    if settings.TOPOLOGY:
        return ReturnNode(nodelist)
    else:
        return ReturnEmpty()

@register.tag(name="begintrends")
def do_trends(parser, token):
    nodelist = parser.parse(('endtrends',))
    parser.delete_first_token()
    if settings.TRENDS:
        return ReturnNode(nodelist)
    else:
        return ReturnEmpty()

class ReturnNode(template.Node):
    def __init__(self, nodelist):
        self.nodelist = nodelist
    def render(self, context):
        output = self.nodelist.render(context)
        return output

class ReturnEmpty(template.Node):
    def render(self, context):
        return ''

