from django.conf import settings
from django.http import HttpResponse
from django.shortcuts import render_to_response
from django.views.decorators.cache import cache_page

from mywlcg.base import release_info, feedparser

@cache_page(3600)
def index(request):
    wrong_ini = False
    if not settings.DEFAULT_PROFILE\
            or not settings.DATABASES['default']['ENGINE']\
            or not settings.DATABASES['default']['NAME']\
            or not settings.DATABASES['default']['USER']\
            or not settings.DATABASES['default']['PASSWORD']:
        wrong_ini = True
    info = release_info()
    about=info['sam_release']
    ver=info['mywlcg_version']
    results={
        'wrong_ini': wrong_ini,
        'config_file': settings.CONFIG_FILE,
        'about': about,
        'version': ver
    }    
    path_prefix(request, results)
    return render_to_response('index.html', results)

@cache_page(3600)
def blog(request):
    sam_blog_url = "https://tomtools.cern.ch/confluence/spaces/createrssfeed.action?types=blogpost&spaces=SAMDOC&maxResults=15&title=[SAM+Doc]+Blog+Feed&publicFeed=false"
    feed = feedparser.parse(sam_blog_url)
    a=feed.entries[0:3]
    return render_to_response('blog.html', {'entries': feed.entries[0:3],'hentries': feed.entries[3:6]})

def error_400(request):
    return render_to_response('400.html', path_prefix(request, {}))

def error_404(request):
    return render_to_response('404.html', path_prefix(request, {}))

def error_500(request):
    return render_to_response('500.html', path_prefix(request, {}))
 
def path_prefix(request,results):
    results['PATH'] = request.META.get('SCRIPT_NAME')
    results['ismyegi'] = 'myegi' in request.path
    results['ismywlcg'] = 'mywlcg' in request.path
    return results
