from django.db.models import Sum
from django.http import HttpResponse
from django.db import connection
from django.shortcuts import render_to_response
from django.shortcuts import redirect
from django.utils import simplejson
from django.views.decorators.cache import cache_page
from django.db.models.query_utils import Q
from mywlcg import settings
from mywlcg.mdb.models import *
from mywlcg.filters.views import parse_filters_gridmap
from datetime import date,datetime,timedelta
import time as ptime
import calendar
import urllib2
import simplejson
import string
from mywlcg.filters.lib import get_grouptype, get_vo_profile, colorgradient
from mywlcg.base.views import path_prefix

color = {
   'OK': '#4f4',
   'WARNING': '#c2ffad',
   'CRITICAL': '#f44',
   'DOWNTIME': '#ff4',
   'UNKNOWN': '#888',
   'MISSING': '#646d7e',
   'N/A': '#444',
   'REMOVED': '#b8f',
}

gtid=GroupType.objects.get(typename='Region').id 

@cache_page(3600)
def index(request):
    results = {}
    if request.GET.get("date"):
      results['date']=request.GET.get("date")
    else:
      results['date']=datetime.utcnow().strftime('%d-%m-%Y %H:%M:%S')
    results = parse_filters_gridmap(request, results)
    results['filters_summary'] = results['filters_summary'] + ', Date: '\
				 + results['date'] + ' UTC'
    return render_to_response('gridmap_index.html', results)

def cal_data(havail,dview,show,services,grouptype,profile,timestamp,revdate,site,siteid=0,area=0,desc='Number: '):
    services = services.values(
    				'id',
    				'hostname',
    				'flavour__flavourname',
    				'ismonitored',
    				'isdeleted'
    			)
    services =services.order_by('id').distinct()
    results_services = []
    services_num = 0
    if dview=='Status':
       if havail in ['H','D']:
          start=datetime.utcfromtimestamp(timestamp)
          end=datetime.utcfromtimestamp(timestamp)+timedelta(days=1)
       elif havail=='W':
           end=datetime.utcfromtimestamp(timestamp)
           start=end-timedelta(days=end.weekday())
           end=end+timedelta(days=(7-end.weekday()))
       else:
          end=datetime.utcfromtimestamp(timestamp)
          start=end-timedelta(days=(end.day-1))
	  end=end+timedelta(days=(calendar.monthrange(end.year,end.month)[1]-end.day+1))
       url='../ss/?profile='+profile\
		+'&filters-value-Sites='+str(siteid)\
		+'&startdate='+str((start.date()).strftime("%d-%m-%Y").lstrip("0"))\
		+'&enddate='+str((end.date()).strftime("%d-%m-%Y").lstrip("0"))
    else:
       url='../sa/?profile='+profile\
		+'&filters-value-Sites='+str(siteid)\
		+'&resolution='+havail+'&starttime='+str(timestamp)\
		+'&endtime='+str(timestamp)
 
    for service in services:
        status = ''
        if dview=='Status':
            status_query = StatusChangeServiceProfile.objects\
				.filter(
					profile = profile,
					service	= service['id'],
					timestamp__lte=timestamp
				).order_by('-timestamp')\
				.values_list('metricstatus__description','timestamp')
        else:
           status_query = eval('ACE_'+havail+'_AVAILABILITY').objects\
				.filter(
					 PROFILE = profile,
                                         service = service['id'],
					 TIMESTAMP__lte = revdate
                                ).order_by('-TIMESTAMP')\
                                .values_list('AVAILABILITY','TIMESTAMP')

        if status_query:
          status = status_query[0][0]
          ctimestamp = status_query[0][1]
          if dview=='Availability' or status != 'REMOVED' or timestamp - ctimestamp <= 3600:
            services_num += 1
            name=site
            ndata=''
            typename=get_grouptype(Profile.objects.get(id=profile,isdeleted='N').atp_vo.voname)
            if area==0 and show:
                name=VoServiceGroup.objects\
                        .filter(
				groups__group_type__typename__iexact =typename,
				service=service['id'],
				groups__isdeleted='N',
                                isdeleted='N'
			).values_list('groups__groupname')\
                        .order_by('groups__groupname')\
                        .distinct()[0][0]
                ndata=name + ': ' 
	    if show:
                  ndata=ndata + service['hostname']\
                                         + ' (' + service['flavour__flavourname'] + ')'
            if dview=='Availability':
               if status>=0:
                  status=status*100
                  showcolor='#'+colorgradient(1,status)
                  status=str(round(status,2))+'%'
               else:
		  showcolor='#787878'
                  status='Unknown'
            else:
               showcolor=color[status]
           
	    results_services.append({
                    'id': name + ': ' + service['hostname'] + '/'\
				 + service['flavour__flavourname'],
                    'name': ndata,
                    'children': [],
                    'data': {
                        '$area': 1,
                        '$color': showcolor,
                        'status': status,
                        'name': name + ': ' + service['hostname']\
                                         + ' (' + service['flavour__flavourname'] + ')',
                        'url': url,
                        'monitored': service['ismonitored'],
                        'deleted': service['isdeleted'],
                    },
            })

    if area:
        services_num=area
    
    if not siteid:
        url = ''
    if services_num:
        results=({
                   'id': site,
                   'name': site,
                   'data': {
                       '$area': services_num,
                       'playcount': desc + str(services_num),
                       'name': site,
                       'url': url,
                   },
                   'children': results_services,
         })
        return (services_num,results)
    return (0,0)

def find_size(size,site,sdata):
    if size==4:
        return (1,'Sites: ')
    if size!=3:
       storecap = SiteStoreCap.objects.filter( site__sitename= site)

    playcount=1
    if size==0:
      storecap = storecap.values_list('phycpucount')
      desc='Physical CPUs: '
    elif size==1:
      storecap = storecap.values_list('logcpucount')
      desc='Logical CPUs: '
    elif size==2:
      storecap = storecap.values_list('hspec06')
      desc='HSPEC06: '
    else:
      for y in sdata: 
	if y[0] == site:
           playcount=y[10]
           break
      desc='Running Jobs: '
    if size!=3:
      if len(storecap):
        if storecap[0][0]>0:
            playcount=storecap[0][0]
    
    return (playcount,desc)

def gridmap_json(request,timestamp,revdate):
    vos,vo,profile=get_vo_profile(request)
    flavour=int(request.GET.get("flavour") or 0)
    show=int(request.GET.get("show") or 0)
    grouptype=int(request.GET.get("grouptype") or GroupType.objects.get(typename='Region').id)
    size=int(request.GET.get("size") or 1)
    voname=Vo.objects.get(id=vo).voname
    profilename=Profile.objects.get(id=profile,isdeleted='N').name
    dview = request.GET.get("dview") or 'Status'
    havail=request.GET.get("havail") or 'D'
    
    serv_flav = Profile.objects.filter(id = profile,isdeleted='N')[0].metricinstances\
			.values_list('atp_service_type_flavour',flat='True')\
			.distinct('atp_service_type_flavour')
    groups = VoServiceGroup.objects
    results={}
    path_prefix(request,results)
    if results['PATH'].find('mywlcg')==-1:
        groups=groups.exclude(groups__groupname='OSG')
    groups=groups.filter(
			service__flavour__in=serv_flav,
			groups__group_type=grouptype,
			groups__isdeleted='N'
			).values_list('groups__groupname',flat='True')\
			.order_by('groups__groupname').distinct()
                     
    if grouptype!=gtid:
        groups = groups.filter(vo=vo)

    results = []

    sdata=[]
    if size==3: 
      req = urllib2.Request("http://gstat-prod.cern.ch/gstat/summary/GRID/WLCG/json/")
      opener = urllib2.build_opener()
      f = opener.open(req)
      sdata =  simplejson.load(f)
      sdata=sdata['aaData']
   
    algo = ''
    #if settings.ACE:
     #    algo = AceAlgorithmProfileMap.objects.filter(profile = profile)\
	#		.values_list('algorithm__site_algo')
	# if algo:
	#	algo=algo[0][0]	    

    for group in groups:       
             sites1 =  VoServiceGroup.objects\
                        .filter(groups__groupname =group,
				service__isdeleted='N',
                                groups__isdeleted='N',
                                isdeleted='N')\
                        .values_list('service',flat=True)
             typename=get_grouptype(voname)
             sites = VoServiceGroup.objects\
                        .filter(
				groups__group_type__typename__iexact =typename,
				service__in=sites1,
				groups__isdeleted='N',
				isdeleted='N'
			)
             if grouptype!=gtid:
                 sites = sites.filter(vo=vo)

             sites = sites.values_list('groups__groupname',flat=True)\
                        .order_by('groups__groupname').distinct()

             siteinfo=''
             totalarea=0
             results_sites = []
             for site in sites:
                  status_query=0
                  flav=0
                  if settings.ACE:
                     if dview=='Status':
                        status_query=AceSiteStatus.objects\
				.filter(
					profile = profile, 
					grouping__groupname = site,
					timestamp__lte=revdate,
				).order_by('-timestamp')\
				.values_list('metricstatus__description',
					'timestamp')
                     else:
                         status_query = eval('ACE_'+havail+'_SITE_AVAILABILITY').objects\
				.filter(
					 PROFILE = profile,
                                         GROUPING__groupname = site,
					 TIMESTAMP__lte = revdate
                                ).order_by('-TIMESTAMP')\
                                .values_list('AVAILABILITY','TIMESTAMP')
                      
                  if status_query:
                      status = status_query[0][0]
                      ctimestamp = calendar.timegm(status_query[0][1].timetuple())
                  else:
                      status= 'N/A'
		  name=''
		  if show:
 			name=site
                  if dview=='Availability' or status != 'REMOVED' or timestamp - ctimestamp <= 3600:
                    area,desc=find_size(size,site,sdata)
                    if dview=='Availability' and status!='N/A':
                       if status>=0:
                          status=status*100
                          showcolor='#'+colorgradient(1,status)
                          status=str(round(status,2))+'%'
                       else:
			  showcolor='#787878'
                          status='Unknown'
                    else:
                       showcolor=color[status]

                    if area:
                      siteinfo= siteinfo + site + ','
                      totalarea=totalarea+area    
                      results_sites.append({
                                            'id': site+'/'+group,
                                            'name': name,
                                            'data': {
                                                     '$area': area,
                                                     'playcount': desc + str(area),
                                                     'group':group,
                                                     '$color': showcolor,
                                                     'status': status,
                                                     'name': site,
                                                     'algorithm': algo,
                                            },
                       })
          
             if totalarea:
                results.append({
                                'id': group,
                                'name': group,
                                'children': results_sites,
                                'data': {
                                         '$area': totalarea,
                                         'playcount': desc+str(totalarea),
                                         'siteinfo': siteinfo,
                                         'name': group,
                                 },
                 })
    return results

def group_json(request,timestamp,revdate):
    profile=request.GET.get("profile")
    groupnames=request.GET.get("groupname")
    sitename=request.GET.get("sitename")
    flavour=int(request.GET.get("flavour"))
    grouptype=int(request.GET.get("grouptype") )
    vo=request.GET.get("vo")
    size=int(request.GET.get("size"))
    show=int(request.GET.get("show") or 0)
    dview = request.GET.get("dview") or 'Status'
    havail=request.GET.get("havail") or 'D'

    voname=Vo.objects.get(id=vo).voname
    profilename=Profile.objects.get(id=profile,isdeleted='N').name
    if groupnames.find('Tier') == -1:
          gname=groupnames.split()
    else: 
          gname=[groupnames,]

    results = []
    for groupname in gname:
      totarea=0
      if flavour==0:
        sites1 =  VoServiceGroup.objects\
                        .filter(groups__groupname =groupname,
				service__isdeleted='N',
                                groups__isdeleted='N',
                                isdeleted='N')\
                        .values_list('service',flat=True)
        typename=get_grouptype(voname)
        sites = VoServiceGroup.objects\
                        .filter(
                                groups__group_type__typename__iexact =typename,
                                service__in=sites1,
                                service__isdeleted='N',
				groups__isdeleted='N',
				isdeleted='N'
                        )
        
        if grouptype!=gtid:
             sites = sites.filter(vo=vo)
        if sitename:
             sites = sites.filter(groups__groupname=sitename)

        sites = sites.values_list('groups__groupname','groups')\
                        .order_by('groups__groupname').distinct()
      else:
        site=ServiceTypeFlavour.objects.get(id=flavour).flavourname
        if grouptype==gtid:
           services = Service.objects\
				.filter(
					flavour = flavour,
					site__sitegroup__groups__groupname = groupname,
					isdeleted='N'
				)
        else:
          services1=VoServiceGroup.objects\
			.filter(
				vo=vo,
				groups__groupname =groupname,
                                service__flavour=flavour,
				isdeleted='N'
			).values_list('service',flat='True').order_by('service').distinct()
          services=Service.objects.filter(id__in=services1)
        if sitename:
              services = services.filter(site__sitename=sitename)

      sdata=[]
      if size==3: 
        req = urllib2.Request("http://gstat-prod.cern.ch/gstat/summary/GRID/WLCG/json/")
        opener = urllib2.build_opener()
        f = opener.open(req)
        sdata =  simplejson.load(f)
        sdata=sdata['aaData']

      tempres=[]
      if flavour==0:
         siteinfo=''
         for site in sites:
           siteinfo= siteinfo + site[0] + ','
           services = Service.objects.filter(site__sitename = site[0],isdeleted='N')
           area,desc=find_size(size,site[0],sdata)
           totalarea,res=cal_data(havail,dview,show,services,grouptype,profile,timestamp,revdate,site[0],site[1],area,desc)
           totarea=totarea+totalarea
           if res:
             tempres.append(res)
         if totarea:
            results.append({
              'id': groupname,
              'name': groupname,
              'children': tempres,
              'data': {
			 '$area': totarea,
                         'siteinfo': siteinfo,
			 'playcount': desc+str(totarea),
			 'name': groupname,
		 },
             })
      else:
          totalarea,res=cal_data(havail,dview,show,services,grouptype,profile,timestamp,revdate,site)
          if totalarea:
             tempres.append(res)
             results.append({
                 'id': groupname,
                 'name': groupname,
                 'children': tempres,
                 'data': {
                         '$area': totalarea,
                         'name': groupname,
                 },
             })
    return results 
    
@cache_page(600)
def json(request):
    groupname=request.GET.get("groupname")
    gdate=request.GET.get("date") 

    if not gdate:
       gdate=datetime.utcnow().strftime('%d-%m-%Y %H:%M:%S')
    
    if ':' in gdate:
       timestamp=int(calendar.timegm(ptime.strptime(gdate, '%d-%m-%Y %H:%M:%S')))
       revdate1=gdate.split(' ')
       revdate2=revdate1[0].split('-')
       revdate=revdate2[2]+'-'+revdate2[1]+'-'+revdate2[0]+' '+revdate1[1]
    else:
       timestamp=int(calendar.timegm(ptime.strptime(gdate, '%d-%m-%Y')))
       revdate2=gdate.split('-')
       revdate=revdate2[2]+'-'+revdate2[1]+'-'+revdate2[0]
    if not groupname:
         results=gridmap_json(request,timestamp,revdate)
    else:
         results=group_json(request,timestamp,revdate)

    ret = {
        'id': '',
        'name': '',
        'children': results,
    }

    return HttpResponse(
        simplejson.dumps(ret, indent=4),
        mimetype='application/json'
    )

def onshow(request):
       profile=request.GET.get("profile")
       site=request.GET.get("site")
       gdate=request.GET.get("date")
       dview = request.GET.get("dview") or 'Status'
       havail=request.GET.get("havail") or 'D'
       if ':' in gdate:
	       revdate1=gdate.split(' ')
	       revdate2=revdate1[0].split('-')
	       revdate=revdate2[2]+'-'+revdate2[1]+'-'+revdate2[0]+' '+revdate1[1]
       else:
	       revdate2=gdate.split('-')
	       revdate=revdate2[2]+'-'+revdate2[1]+'-'+revdate2[0]
       sflav =  ServiceTypeFlavour.objects.filter(isdeleted='N')\
				.values_list('flavourname',flat=True)\
				.order_by('flavourname').distinct()
       result=[]
       if settings.ACE:
          for sf in sflav:
              if dview=='Status':
	         flav=AceFlavourStatus.objects\
		     .filter(
			profile = profile,
			grouping__groupname = site,
			timestamp__lte=revdate,
			service_type_flavour__flavourname=sf
		     ).order_by('-timestamp')\
		     .values_list('metricstatus__description',flat=True)
	         if flav.count() and flav[0] != 'REMOVED':
	             result.append((sf,flav[0]))
	      else:
                  flav = eval('ACE_'+havail+'_FLAVOUR_AVAILABILITY').objects\
				.filter(
					 PROFILE = profile,
                                         GROUPING__groupname = site,
					 TIMESTAMP__lte = revdate,
					 SERVICE_TYPE_FLAVOUR__flavourname=sf
                                ).order_by('-TIMESTAMP')\
                                .values_list('AVAILABILITY',flat=True)
                  if flav.count():
                     if flav[0]>=0:
	               result.append((sf,str(round(flav[0]*100,2))+'%'))
                     else:
	               result.append((sf,'Unknown'))

       ret = {'flavour': result,}
       return HttpResponse(
        simplejson.dumps(ret, indent=4),
        mimetype='application/json'
       )
     
def onshowsize(request):
    sitelist=request.GET.get("sitelist")
    size=int(request.GET.get("size"))
    if size==4:
       ret={'size':[]}
    else:
       site=sitelist.split(',')
       storecap = SiteStoreCap.objects.filter( site__sitename__in= site)

       playcount=1
       if size==0:
          name = 'phycpucount'
       elif size==1:
          name = 'logcpucount'
       elif size==2:
          name = 'hspec06'
       name1='-'+name
       storecap = storecap.values_list('site__sitename',name).order_by(name1).distinct()
       ret = {'size': list(storecap),}

    return HttpResponse(
       simplejson.dumps(ret, indent=4),
       mimetype='application/json'
    ) 
