import gd
import time as ptime
import calendar
from datetime import date, timedelta, datetime
from django.http import HttpResponse, HttpResponseBadRequest
from django.shortcuts import render_to_response
from django.views.decorators.cache import cache_page
from mywlcg.filters.lib import parse_params, get_grouptype, getname, colorgradient
from mywlcg.filters.views import parse_filters_sa
from django.db.models.query_utils import Q
from django.db.models import Sum
from mywlcg.mdb.models import ACE_H_SITE_AVAILABILITY
from mywlcg.mdb.models import ACE_D_SITE_AVAILABILITY
from mywlcg.mdb.models import ACE_W_SITE_AVAILABILITY
from mywlcg.mdb.models import ACE_M_SITE_AVAILABILITY
from mywlcg.mdb.models import ACE_H_FLAVOUR_AVAILABILITY
from mywlcg.mdb.models import ACE_D_FLAVOUR_AVAILABILITY
from mywlcg.mdb.models import ACE_W_FLAVOUR_AVAILABILITY
from mywlcg.mdb.models import ACE_M_FLAVOUR_AVAILABILITY
from mywlcg.mdb.models import ACE_H_AVAILABILITY
from mywlcg.mdb.models import ACE_D_AVAILABILITY
from mywlcg.mdb.models import ACE_W_AVAILABILITY
from mywlcg.mdb.models import ACE_M_AVAILABILITY
from mywlcg.mdb.models import VoServiceGroup
from mywlcg.mdb.models import Profile
from mywlcg.mdb.models import Groups
from mywlcg.mdb.models import GroupType
from dateutil.relativedelta import relativedelta
from mywlcg.base.views import path_prefix
import shlex
from django.db import connection
import urllib2
import urllib
#import webbrowser
import simplejson
import cookielib
import httplib
import string

def setdate(request,results):
    results['startdate'] = request.GET.get("startdate")
    results['starttime']=request.GET.get("starttime")
    results['start_time']=request.GET.get("start_time")
    results['endtime']=request.GET.get("endtime")
    results['enddate'] = request.GET.get("enddate")
    results['end_time']=request.GET.get("end_time")

    if results['dateorperiod'] == 'dt':
        if not results['startdate'] and not results['starttime'] and  not results['start_time']:
            results['startdate'] = (datetime.utcnow().date() - timedelta(days=31)).strftime('%d-%m-%Y')
            results['starttime'] = int(calendar.timegm(ptime.strptime(results['startdate'], '%d-%m-%Y')))

        if results['start_time']:
            results['starttime'] = int(calendar.timegm(ptime.strptime(results['start_time'],'%Y-%m-%dT%H:%M:%SZ')))

        if not results['enddate'] and not results['endtime'] and not results['end_time']:
            results['enddate']=(datetime.utcnow().date() - timedelta(days=1)).strftime('%d-%m-%Y')
            if results['resolution']=='H':
                results['enddate'] = results['startdate']
            results['endtime']= int(calendar.timegm(ptime.strptime(results['enddate'], '%d-%m-%Y')))

        if results['end_time']:
            results['endtime'] = int(calendar.timegm(ptime.strptime(results['end_time'],
                                            '%Y-%m-%dT%H:%M:%SZ')))
    elif results['dateorperiod'] == 'pd':
        results['period']=str(request.GET.get("period") or 'pM')
        if results['period'] == 'pD':
            results['resolution'] = 'H'
            results['startdate'] = datetime.utcnow().date().strftime('%d-%m-%Y')
            results['enddate'] = datetime.utcnow().date().strftime('%d-%m-%Y')
        elif results['period'] == 'pM':
            results['resolution'] = 'D'
            results['startdate'] = (datetime.utcnow().date()-timedelta(days=30)).strftime('%d-%m-%Y')
            results['enddate'] = datetime.utcnow().date().strftime('%d-%m-%Y')
        elif results['period'] == 'p6':
            results['resolution'] = 'W'
            results['startdate'] = (datetime.utcnow().date()-timedelta(days=30*6)).strftime('%d-%m-%Y')
            results['enddate'] = datetime.utcnow().date().strftime('%d-%m-%Y')
        elif results['period'] == 'pY':
            results['resolution'] = 'M'
            results['startdate'] = (datetime.utcnow().date()-timedelta(days=337)).strftime('%d-%m-%Y')
            results['enddate'] = datetime.utcnow().date().strftime('%d-%m-%Y')

    if results['enddate']:
        results['endtime'] = int(calendar.timegm(ptime.strptime(results['enddate'], '%d-%m-%Y')))
    if results['startdate']:
        results['starttime'] = int(calendar.timegm(ptime.strptime(results['startdate'], '%d-%m-%Y')))

    results['starttime']=int( results['starttime'])
    s = datetime.utcfromtimestamp(results['starttime']).date()
    results['endtime']=int(results['endtime'])
    e = datetime.utcfromtimestamp(results['endtime']).date()

    if results['resolution'] == 'W':
        s = datetime.utcfromtimestamp(calendar.timegm(s.timetuple())-s.weekday()*24*3600).date()
        results['starttime'] = int(calendar.timegm(s.timetuple()))
        e = datetime.utcfromtimestamp(calendar.timegm(e.timetuple())+(6-e.weekday())*24*3600).date()
        results['endtime'] = int(calendar.timegm(e.timetuple()))
    elif results['resolution'] == 'M':
        s = datetime.utcfromtimestamp(calendar.timegm(s.timetuple())-(s.day-1)*24*3600)
        results['starttime'] = int(calendar.timegm(s.timetuple()))
        e = datetime.utcfromtimestamp(
                                  calendar.timegm(e.timetuple())
                                  +(calendar.monthrange(e.year,e.month)[1]-e.day)*24*3600
                  )
        results['endtime'] = int(calendar.timegm(e.timetuple()))
    if not results['start_time']:
        results['start_time'] =  str(s.strftime("%Y-%m-%dT%H:%M:%SZ").lstrip("0"))
    if not results['startdate']:
        results['startdate'] =  str(s.strftime("%d-%m-%Y").lstrip("0"))
    if not results['end_time']:
        results['end_time'] =  str(e.strftime("%Y-%m-%dT%H:%M:%SZ").lstrip("0"))
    if not results['enddate']:
        results['enddate'] =  str(e.strftime("%d-%m-%Y").lstrip("0"))
    return results


@cache_page(600)
def index(request):
    results={}
    results['img']=int(request.GET.get("img") or 0)
    results = parse_filters_sa(request, results)
    try:
        results = setdate(request, results)
    except ValueError, (ve):
        return HttpResponseBadRequest(
            render_to_response(
                '400.html',
                {'error': 'the provided dates are not valid'}
            )
        )
    if results['img']:
        return json(request,results)
    else:
        results['profile_name']=getname("Profile","name", results['profile'])
        return render_to_response('sa_index.html', results)

@cache_page(600)
def heading(request):
    profile=int(request.GET.get("profile") )
    group=int(request.GET.get("group") or 0)
    site=int(request.GET.get("site") or 0)
    graph=int(request.GET.get("graph") or 1)
    resolution = request.GET.get("resolution") or 'D'
    if graph==1:
        type='Availability';
    else:
        type='Reliability';
    service=int(request.GET.get("service") or 0)
    service_type_flavour=int(request.GET.get("service_type_flavour") or 0)
    if group:
        groupname=getname("Groups","groupname",site)
    profilename=getname("Profile","name",profile)
    if resolution=='H':
        resolution="Hourly"
    elif resolution=='D':
        resolution="Daily"
    elif resolution=='W':
        resolution="Weekly"
    else:
        resolution="Monthly"
    if group==0:
        data="Site "+type+" Profile:"+profilename+" ("+resolution+" Report)"
    elif service_type_flavour==1:
        data="Individual Service "+type+" for Site:"+groupname\
                         +" Profile:"+profilename+" ("+resolution+" Report)"
    elif service==1:
        data="Service Instance "+type+" for Site:"+groupname\
                         +" Profile:"+profilename+" ("+resolution+" Report)"
    else:
        data="Overall Service "+type+" for site:"+groupname\
                         +" Profile:"+profilename+" ("+resolution+" Report)"
    return render_to_response('sa_heading',{"data":data})

@cache_page(600)
def json(request,results=0):
    # Datatables GET parameters
    # http://www.datatables.net/usage/server-side
    img=int(request.GET.get("img") or 0)
    plus=int(request.GET.get("plus") or 0)
    mcolor=int(request.GET.get("mcolor") or 0)
    starttime = float(request.GET.get("starttime") or 0)
    endtime = float(request.GET.get("endtime") or 0)
    group=int(request.GET.get("group") or 0)
    graphtype=request.GET.get("graphtype")
    graph=int(request.GET.get("graph") or 1)
    view=int(request.GET.get("view") or 2)
    profile=int(request.GET.get("profile") or 0 )
    service=int(request.GET.get("service") or 0)
    service_type_flavour=int(request.GET.get("service_type_flavour") or 0)
    site=int(request.GET.get("site") or 0)
    site_name=request.GET.get("site_name") or 0
    groups=request.GET.get("groups") or 0
    service_name=request.GET.get("service_name") or 0
    profile_name=request.GET.get("profile_name") or 0
    resolution = request.GET.get("resolution") or 'D'
    production = int(request.GET.get('production', 1))
    preproduction = int(request.GET.get('preproduction', 1))
    service_type_flavour_name=request.GET.get("service_type_flavour_name") or 0
    if graphtype:
        if graphtype=='Reliability':
            graph= 0
        else:
            graph=1
    else:
        if graph==1:
            graphtype='Availability';
        else:
            graphtype='Reliability';
    if img:
        view=3
    if results:
        starttime=results['starttime']
        endtime=results['endtime']
        group=1
        if not profile_name or not site_name:
            return HttpResponseBadRequest(
                render_to_response(
                    '400.html',
                    {'error': 'profile_name or site_name must be provided'}
                )
            )

    queryset =0
    s=datetime.utcfromtimestamp(starttime).date()
    e=datetime.utcfromtimestamp(endtime).date()
    if(s==e):
        e=datetime.utcfromtimestamp(calendar.timegm(s.timetuple())+24*3600-1)
    start=str(s.strftime("%d-%m-%Y").lstrip("0"))
    end=str(e.strftime("%d-%m-%Y").lstrip("0"))
    e_his=datetime.utcfromtimestamp(calendar.timegm(e.timetuple())+24*3600)
    end_his=str(e_his.strftime("%d-%m-%Y").lstrip("0"))

    diff=float(calendar.timegm(e.timetuple())-calendar.timegm(s.timetuple()))

    if resolution=='H':
        title=graphtype+' on '+start
        xtitle='Time (GMT)'
        twidth=3600
        diff= 86400.0
        imgsize=875
        timediff = timedelta(hours=1)
    elif resolution=='D' or img==2:
        title=graphtype+' from '+start+' to '+ end
        xtitle='Dates dd-mm'
        imgsize=880
        twidth=86400
        diff = diff + twidth
        timediff = timedelta(days=1)
    elif resolution=='W':
        imgsize=880
        title=graphtype+' from '+start+' to '+ end
        xtitle='Dates dd-mm'
        twidth=604800
        timediff = timedelta(weeks=1)
    else:
        imgsize=888
        timediff = relativedelta(months=+1)
        title=graphtype+' from '+start+' to '+ end
        xtitle='Dates mm-yy'
        twidth=2592000
        diffmod=(diff/86400)%30
        if diffmod<28:
            diff=diff-(diffmod*86400)
        else:
            diff=diff+(30-diffmod)*86400
        timediff = relativedelta(months=+1)

    w=twidth/(diff)
    tick=2
    if view==3:
        tick=int(diff/(twidth*3))
    if service_type_flavour==1:
        idtable='ServiceTypeFlavour'
        idfield='flavourname'
        table='ACE_'+resolution+'_FLAVOUR_AVAILABILITY'
        order='SERVICE_TYPE_FLAVOUR'
        mtitle='Service Flavour'
    elif service ==1:
        idtable='Service'
        idfield='hostname'
        table='ACE_'+resolution+'_AVAILABILITY'
        order='service'
    else:
        mtitle='Site'
        idtable='Groups'
        idfield='groupname'
        table='ACE_'+resolution+'_SITE_AVAILABILITY'
        order='GROUPING'

    if profile:
        voname = Profile.objects.get(id=profile,isdeleted='N').atp_vo.voname
    if profile_name:
        voname = Profile.objects.filter(name=profile_name,isdeleted='N').values_list('atp_vo__voname')[0][0]

    type = get_grouptype(voname)
    model = eval(table)
    queryset = model.objects
    if not group:
        queryset = queryset.filter(GROUPING__group_type__typename__iexact=type)

    if img :
        queryset=queryset.filter(TIMESTAMP__range=(s,e),PROFILE__name=profile_name)
        if service_type_flavour:
            queryset=queryset.filter(SERVICE_TYPE_FLAVOUR__flavourname=service_type_flavour_name)
    else:
        queryset=queryset.filter(TIMESTAMP__range=(s,e),PROFILE=profile)

    if not production:
        if 'GROUPING' in model._meta.get_all_field_names():
            queryset = queryset.exclude(GROUPING__servicegroup__service__site__infrasttype='Production')
        else:
            queryset = queryset.exclude(service__servicegroup__service__site__infrasttype='Production')
    if not preproduction:
        if 'GROUPING' in model._meta.get_all_field_names():
            queryset = queryset.exclude(GROUPING__servicegroup__service__site__infrasttype='PPS')
        else:
            queryset = queryset.exclude(service__servicegroup__service__site__infrasttype='PPS')

    voservgroup=VoServiceGroup.objects.filter(isdeleted='N')
    if groups:
        groups_list = groups.split(',')
        if groups_list[len(groups_list)-1] == '':
            groups_list = groups_list[0:len(groups_list)-1]
        service_list=voservgroup.filter(groups__in = groups_list).values_list('service')

        sitelist=[]
        sitelist=voservgroup.filter(
            service__in=service_list,groups__group_type__typename__iexact= type,
            vo__voname=voname
        )

        if not group:
            sitelist=sitelist.values_list('groups').distinct()
            queryset=queryset.filter(GROUPING__in = sitelist)

    idarray=[]
    if service:
        if img:
            ids=voservgroup.filter(
                                   service__flavour__flavourname=site_name,
                                   service__hostname=service_name,
                                   vo__voname=voname
                           ).values_list('service')
        else:
            ids=voservgroup.filter(vo__voname=voname,groups=site)
            if service_type_flavour_name:
                ids=ids.filter(service__flavour__flavourname=service_type_flavour_name)
            ids=ids.values_list('service')
        queryset=queryset.filter(service__in=ids)
    elif group !=0 :
        if img:
            queryset=queryset.filter(GROUPING__groupname=site_name, GROUPING__group_type__typename__iexact= type)
        else:
            if site and groups:
                sitelist=sitelist.filter(groups=site)
                sitelist=sitelist.values_list('groups').distinct()
            else:
                sitelist=[site,]
            site_name=getname('Groups','groupname',site)
            queryset=queryset.filter(GROUPING__in=sitelist, GROUPING__group_type__typename__iexact= type)

    graphdata=[]
    clusters=[]

    if view==3:
        clusters=queryset.values(order)
        clusters=clusters.distinct()
    else:
        clusters=queryset.values(order).annotate(Sum('AVAILABILITY'))\
                           .order_by('-AVAILABILITY__sum',order).distinct()
    if graph==1:
        ytitle='l|i|a|v|A'
        legend='Up|Down'
        colors='66CD00,ff3030,ffff00,505050'
        #colors='00ff00,ff3300,ffff00,505050'
    else:
        legend='Rel|Not Rel'
        ytitle='i|l|e|R'
        colors='1E90FF,ff3030,ffff00,505050'
        #colors='0000cc,ff3300,ffff00,505050'
    wd=''
    for cluster in clusters:
        cluster=cluster[order]
        # Extracting results
        clustername=''
        if service_type_flavour:
            record=queryset.filter(SERVICE_TYPE_FLAVOUR=cluster)
            clustername=record.values_list('SERVICE_TYPE_FLAVOUR__flavourname')[0][0]
        elif service:
            record=queryset.filter(service=cluster)
            mtitle=record.values_list('service__flavour__flavourname')[0][0]
            clustername=record.values_list('service__hostname')[0][0]
        else:
            record=queryset.filter(GROUPING=cluster)
            clustername=record.values_list('GROUPING__groupname')[0][0]

        record=record.order_by('TIMESTAMP')
        if graph==1:
            status_changes=record.values('AVAILABILITY','DOWN','MAINTENANCE', 'TIMESTAMP')
        else:
            status_changes=record.values('RELIABILITY','MAINTENANCE','AMAINTENANCE', 'TIMESTAMP')
        data1=''
        data2=''
        data3=''
        data4=''
        avail=''
        change_time = ''
        maint = ''
        first=1
        loop=datetime.utcfromtimestamp(calendar.timegm(s.timetuple()))
        loopend=datetime.utcfromtimestamp(calendar.timegm(e.timetuple()))
        i=0
        j=0
        while loop <= loopend:

            if i<len(status_changes):
                change=status_changes[i]
            else:
                change['TIMESTAMP']=-1
            if first==1:
                str1=''
            else:
                str1=','
            if change['TIMESTAMP']==loop:
                time1=str(change['TIMESTAMP']).split()

                i=i+1
                if view == 2:
                    if j!=0:
                        maint = maint + ','
                    if change['MAINTENANCE']>0:
                        maint = maint + '80'
                    else:
                        maint = maint + '100'
                if graph ==1:
                    if view==3:
                        if change['AVAILABILITY'] !=-1:
                            data1+=str1+str(change['AVAILABILITY']*100)
                            data2+=str1+str(change['DOWN']*100)
                            data3+=str1+str(change['MAINTENANCE']*100)
                            data4+=str1+'0'
                        else:
                            data1+=str1+'0'
                            data2+=str1+'0'
                            data3+=str1+'0'
                            data4+=str1+'100'
                    else:
                        if change['AVAILABILITY'] !=-1:
                            currcg=colorgradient(1,change['AVAILABILITY']*100)
                            curravail=str(round(change['AVAILABILITY']*100,2))
                        else:
                            curravail='Unknown'
                            currcg='787878'
                        if j==0:
                            width=w
                            cg=currcg
                            curr=curravail
                            wd=str(width)
                        elif (cg == currcg):
                            width=width+w
                            wd=str(width)
                        else:
                            avail+=str1+str(j)+','+str(curr)
                            wd=str(width)
                            data1+=','+cg+','+wd
                            width=w
                            cg=currcg
                            curr=curravail
                            wd=str(width)
                else:
                    if view==3:
                        if change['RELIABILITY'] !=-1:
                            data1+=str1+str(change['RELIABILITY']*100)
                            data2+=str1+str((1-change['RELIABILITY'])*100)
                            data3+=str1+'0'
                            data4+=str1+'0'
                        else:
                            data1+=str1+'0'
                            data2+=str1+'0'
                            if change['AMAINTENANCE']:
                                data3+=str1+'100'
                                data4+=str1+'0'
                            else:
                                data3+=str1+'0'
                                data4+=str1+'100'
                    else:
                        if change['RELIABILITY'] !=-1:
                            currcg=colorgradient(0,change['RELIABILITY']*100)
                            curravail=change['RELIABILITY']*100
                        else:
                            curravail='Unknown'
                            currcg='787878'
                        if j==0:
                            width=w
                            curr=curravail
                            cg=currcg
                            wd=str(width)
                        elif (cg == currcg):
                            width=width+w
                            wd=str(width)
                        else:
                            avail+=str1+str(j)+','+str(curr)
                            wd=str(width)
                            data1+=','+cg+','+wd
                            width=w
                            cg=currcg
                            curr=curravail
                            wd=str(width)
            else:
                time1=str(loop).split()
                if view == 3:
                    data1+=str1+'0'
                    data2+=str1+'0'
                    data3+=str1+'0'
                    data4+=str1+'0'
                else:
                    if j!=0:
                        maint = maint + ','
                    maint = maint + '100'
                    if j==0:
                        width=w
                        cg='ffffff'
                        curr='Data Not Available'
                        wd=str(width)
                    elif cg == 'ffffff':
                        width=width+w
                        wd=str(width)
                    else:
                        wd=str(width)
                        avail+=str1+str(j)+','+str(curr)
                        data1+=','+cg+','+wd
                        width=w
                        curr='Data Not Available'
                        cg='ffffff'

            loop+=timediff
            time2=time1[0].split('-')
            if resolution=='D' or resolution=='W':
                time=time2[2]+'-'+time2[1]
            elif resolution=='M' :
                time=time2[1]+'-'+time2[0]
            else:
                time3=time1[1].split(':')
                time=time3[0]
            if first==1 :
                change_time+=time
                pos='0'
            else:
                if((first-1)%tick==0):
                    time1=time
                    change_time+='|'+time
                    pos+=','+str(j*100*w)
                else:
                    if view==3:
                        change_time+='|'
            first=first+1
            j=j+1
            url=''
            if not img:
                url='../ss?monitored=1' +\
                           '&status=1&status=2&status=3&status=4&status=5' +\
                           '&startdate=' + start + '&enddate=' + end_his +\
                           '&profile=' + str(profile) + '&dateorperiod=dt'
                if service:
                    url = url + '&filters-value-Hostnames='
                elif not service_type_flavour:
                    url = url + '&filters-value-Sites='
                url = url + str(cluster)

        if view==3:
            if j<24:
                k=0
                while k<24-j:
                    data1+=',0'
                    data2+=',0'
                    data3+=',0'
                    data4+=',0'
                    k=k+1

            graphdata.append({
                'id':cluster,
                'name':clustername,
                'data':data1+'|'+data2+'|'+data3+'|'+data4,
                'timestamp':change_time,
                'mtitle':mtitle,
                'url':url
            })

        else:
            data1+=','+cg+','+wd
            avail+=str1+str(j)+','+str(curr)
            graphdata.append({
                'id':cluster,
                'name':clustername,
                'data':data1,
                'timestamp': change_time,
                'mtitle':mtitle,
                'pos':pos,
                'width':(w*100),
                'avail':avail,
                'url':url,
                'site':site,
                'maint':maint
                #'site':record.values_list('GROUPING')[0][0]
            })

    barwidth = '7,1,1'
    if img==2 or diff/twidth>=31:
        barwidth = 'a'
        if diff/86400 >= 61:
            barwidth = barwidth + ',0,1'
        else:
            barwidth = barwidth + ',1,1'
    results = {
        'site_name':site_name,
        'service': service,
        'group': group,
        'service_type_flavour': service_type_flavour,
        'colors':colors,
        'imgsize':imgsize,
        'title':title,
        'xtitle':xtitle,
        'ytitle':ytitle,
        'graphdata':graphdata,
        'plus': plus,
        'mcolor': mcolor,
        'barwidth': barwidth,
        'img': img,
        'legend': legend
    }
    path_prefix(request,results)
    if img:
        callback = 'sa_json_img'
        params = render_to_response(callback, results, mimetype='application/json')
        params = simplejson.loads(params.content)
        data = urllib.urlencode(params)
        # https://tomtools.its.cern.ch/jira/browse/SAM-3168
        # this hack avoids a crash when the data is too big to be plotted through
        # google's image chart service. The plot is simply dismissed.
        image_data = ''
        if len(data) < 8192:
            headers = {"Accept" : "*/*"}
            url = 'http://chart.apis.google.com/chart'
            req = urllib2.Request(url, data, headers)
            image_data = urllib2.urlopen(req).read()
        return HttpResponse(image_data, mimetype="image/png")
    if view ==3:
        callback='sa_json'
    elif view ==2:
        callback='sa_json_q'
    return render_to_response(callback, results)
