--DROP TABLE IF EXISTS
BEGIN
    EXECUTE IMMEDIATE 'DROP TABLE T0T1SERVICETARGETS';
EXCEPTION
    WHEN OTHERS THEN
        --table or view does not exist
        IF SQLCODE != -942 THEN
            RAISE;
        END IF;
END;
/


-- CREATE TABLE AGAIN
CREATE TABLE T0T1SERVICETARGETS (
    AVAILTARGETPERSITE FLOAT(126) NOT NULL,
    RELTARGETPERSITE FLOAT(126) NOT NULL,
    AVAILTARGETBESTSITES FLOAT(126) NOT NULL,
    RELTARGETBESTSITES FLOAT(126) NOT NULL,
    EFFECTIVEFROMTS TIMESTAMP(6)  NOT NULL,
    MODIFIEDTS TIMESTAMP(6)  NOT NULL,
    CONSTRAINT T0T1SERVICETARGETS_PK PRIMARY KEY (EFFECTIVEFROMTS) ENABLE 
); 


-- POPULATE TABLE
INSERT
    INTO T0T1SERVICETARGETS (
        AVAILTARGETPERSITE, RELTARGETPERSITE, AVAILTARGETBESTSITES, RELTARGETBESTSITES,
        EFFECTIVEFROMTS,
        MODIFIEDTS
    )
VALUES (
    0.97, 0.97, 0.98, 0.98,
    to_timestamp('01-JAN-09 00.00.00.000000000','DD-MON-RR HH24.MI.SS.FF'),
    to_timestamp('05-FEB-09 00.00.00.000000000','DD-MON-RR HH24.MI.SS.FF')
);
