(function($){
    $.fn.extend({

        multiple_select: function(options) {
            // original select
            var $this = $(this);
            var selected_values = Array();
            
            settings =  $.extend({
                name: 'mselect',
                no_options: 'Any option'
            }, options);

            var selected = $('<span></span>');
            var input = $('<input type="checkbox"/>');
            var label = $('<label></label>');
            var options_container = $('<div></div>');
            var input_container = $('<div></div>');

            function create_labeled_checkbox(value, text, opt_selected){
                input_id = settings.name + '-value-' + value;
                inp = input.clone();
                inp.attr('value', value);
                inp.attr('id', input_id);
                if (opt_selected){
                    inp.attr('checked', 'checked');
                }

                lb = label.clone();
                lb.attr('for', input_id);
                lb.text(text);

                // bind to add a value on click
                inp.click(function(e){
                    update_value(value, text, $(e.target).is(':checked'));
                    e.stopPropagation();
                });

                // bind label too so we control the event propagation
                lb.click(function(e){
                    e.stopPropagation();
                });

                container = input_container.clone();
                container.append(inp);
                container.append(lb);
                return container;
            }

            function update_value(value, text, checked){
                opt = $this.find('option[value="' + value + '"]');
                if (selected_values.indexOf(text) >= 0 && !checked){
                    opt.removeAttr('selected');
                    selected_values.splice(selected_values.indexOf(text), 1);
                }else{
                    opt.attr('selected', 'selected');
                    selected_values.push(text);
                }

                if (selected_values.length > 0){
                    selected.text(selected_values.join(', '));
                }else{
                    selected.text(settings.no_options);
                }
            }

            return this.each(function() {
                selected.attr('id', settings.name + '-selected');
                selected.css('z-index', '99');
                selected.text(settings.no_options);
                selected.insertBefore($(this));

                $(this).find('option').each(function(idx, el){
                    el = $(el);
                    opt_selected = el.is(':selected');
                    opt = create_labeled_checkbox(el.val(), el.text(), opt_selected);
                    options_container.append(opt);
                    if (opt_selected){
                        update_value(el.val(), el.text());
                    }
                });

                // add option selector to DOM
                options_container.attr('id', settings.name + '-options');
                options_container.css('position', 'absolute');
                options_container.hide();
                options_container.insertAfter(selected);


                // bind selected values container to toogle options
                selected.click(function(e){
                    // isolate this event from the container click event
                    if ($(e.target).is(selected)){
                        options_container.toggle();
                        options_container.css('top', selected.offset().top + 35);
                        options_container.css('left', selected.offset().left);
                        e.stopPropagation();
                    }
                })

                // bind outer container to close the options dialog
                $(settings.container).click(function(){
                    options_container.hide();
                })

                $(this).hide();
            });
        }
    });
})(jQuery);